\name{getErrorRates}
\alias{getErrorRates}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Estimates error rates in a sequencing run (one lane of a flow cell on
Genome Analyzer).
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
getErrorRates(rcnts.file, type = "sub")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{rcnts.file}{
File containing read counts. The file should have two columns separated
by a single space. The first column contains the reads, and the second
column contains the read frequencies. The reads must be decreasingly ordered by read
frequency.
}
  \item{type}{
Which type of read errors to estimate. Can be one of "sub", "indel" or "all".
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%     return(list(perReadER = perReadER, cycleER = cycleER, tags = tag.cnt.new.order, 
%         shadows = shadow.cnt.d1and2, shadows.1 = shadow.cnt.d1, 
%         shadows.2 = shadow.cnt.d2, stable.1 = shadow.table.1, 
%         stable.2 = shadow.table.2))
  \item{perReadER }{per read error rate}
  \item{cycleER }{error rate by read position}
  \item{tags}{read counts of the 1000 most frequently occuring reads
    (1000 largest read counts)}
  \item{shadows}{shadow counts for the 1000 most frequently occuring reads}
  \item{shadows.1}{table of shadow counts by read position. shadows of
    distance 1 from the original read only.}
  \item{shadows.2}{table of shadow counts by read position. shadows of
    distance 2 from the original read only.}
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
% \examples{
% ##---- Should be DIRECTLY executable !! ----
% ##-- ==>  Define data, use random,
% ##--	or do  help(data=index)  for the standard data sets.

% ## The function is currently defined as
% function (rcnts.file, type = "sub") 
% {
%     freq.data = read.table(rcnts.file, sep = " ", header = F)
%     tags = as.character(freq.data[, 1])
%     counts = freq.data[, 2]
%     idx.N = grep("N", tags)
%     idx.A = grep(paste(rep("A", nchar(tags[1])), collapse = ""), 
%         tags)
%     idx.C = grep(paste(rep("C", nchar(tags[1])), collapse = ""), 
%         tags)
%     idx.G = grep(paste(rep("G", nchar(tags[1])), collapse = ""), 
%         tags)
%     idx.T = grep(paste(rep("T", nchar(tags[1])), collapse = ""), 
%         tags)
%     idx.filter = c(idx.N, idx.A, idx.C, idx.G, idx.T)
%     if (length(idx.filter) > 0) {
%         tags = tags[-idx.filter]
%         counts = counts[-idx.filter]
%     }
%     ts.counts.only2 = getShadow2Cnts.new(1:1000, tags, counts, 
%         method = type)
%     ts.counts.org = getShadowCnts.new(1:1000, tags, counts, method = type)
%     d2neigh.order = match(rownames(ts.counts.org[[1]]), rownames(ts.counts.only2[[1]]))
%     if (sum(is.na(d2neigh.order)) > 0) {
%         order.na = which(is.na(d2neigh.order))
%         d2neigh.order.noNA = d2neigh.order[-order.na]
%         shadow.cnt.d1and2 = c(ts.counts.only2[[1]][d2neigh.order.noNA, 
%             2] + ts.counts.org[[1]][-order.na, 2], ts.counts.org[[1]][order.na, 
%             2])
%         shadow.cnt.d1 = rbind(ts.counts.org[[2]][-order.na, ], 
%             ts.counts.org[[2]][order.na, ])
%         d2.0.mx = matrix(0, length(order.na), ncol(shadow.cnt.d1))
%         shadow.cnt.d2 = rbind(ts.counts.only2[[2]][d2neigh.order.noNA, 
%             ], d2.0.mx)
%         tag.cnt.new.order = c(ts.counts.org[[1]][-order.na, 1], 
%             ts.counts.org[[1]][order.na, 1])
%     }
%     else {
%         if (length(d2neigh.order) > 0) {
%             d2neigh.order.noNA = d2neigh.order
%             shadow.cnt.d1and2 = c(ts.counts.only2[[1]][d2neigh.order.noNA, 
%                 2] + ts.counts.org[[1]][, 2])
%             shadow.cnt.d1 = ts.counts.org[[2]]
%             shadow.cnt.d2 = ts.counts.only2[[2]][d2neigh.order.noNA, 
%                 ]
%             tag.cnt.new.order = c(ts.counts.org[[1]][, 1])
%         }
%         else {
%             shadow.cnt.d1and2 = rep(0, length(ts.counts.org[[1]][, 
%                 1]))
%             shadow.cnt.d1 = ts.counts.org[[2]]
%             shadow.cnt.d2 = ts.counts.only2[[2]]
%             tag.cnt.new.order = c(ts.counts.org[[1]][, 1])
%         }
%     }
%     order.s1 = match(names(tag.cnt.new.order), rownames(ts.counts.org[[1]]))
%     order.s2 = match(names(tag.cnt.new.order), rownames(ts.counts.only2[[1]]))
%     shadow.table.1 = ts.counts.org$shadow.table[order.s1]
%     shadow.table.2 = ts.counts.only2$shadow.table[order.s2]
%     perReadER = getErrorRates.free.intcpt(tag.cnt.new.order, 
%         shadow.cnt.d1and2)
%     names(perReadER) = c("error rate", "standard error")
%     cycleER = getPositionErrorRates.free.intcpt(tag.cnt.new.order, 
%         shadow.cnt.d1, shadow.cnt.d2)
%     colnames(cycleER) = c("error rate", "standard error")
%     return(list(perReadER = perReadER, cycleER = cycleER, tags = tag.cnt.new.order, 
%         shadows = shadow.cnt.d1and2, shadows.1 = shadow.cnt.d1, 
%         shadows.2 = shadow.cnt.d2) );
%   }
% }
% % Add one or more standard keywords, see file 'KEYWORDS' in the
% % R documentation directory.
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
